using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Extended;

namespace H2UtilityToolkit.Essentials
{
    /// <summary>
    /// 
    /// </summary>
    public class Header
    {
        #region Instance Data

        private Map __map__;
        private string __head__;
        private int __version__;
        private int __filesize__;
        private int __indexOffset__;
        private int __indexSize__;
        private int __metaStart__;
        private int __metaSize__;
        private int __nonRawSize__;
        private byte[] __origin__;
        private string __buildDate__;
        private int __mapTypeIndex__;
        private MapType __mapType__;
        private int __crazyOffset__;
        private int __crazySize__;
        private int __stringTable128Offset__;
        private int __stringTableCount__;
        private int __stringTableSize__;
        private int __stringTableIndexOffset__;
        private int __stringTableOffset__;
        private string __internalName__;
        private string __scenarioName__;
        private int __fileTableCount__;
        private int __fileTableOffset__;
        private int __fileTableSize__;
        private int __fileTableIndexOffset__;
        private int __checksum__;
        private string __foot__;

        #endregion

        #region Accessors

        ///<summary>
        /// Map
        ///</summary>
        protected Map Map { get { return __map__; } set { __map__ = value; } }
        ///<summary>
        /// Head
        ///</summary>
        public string Head { get { return __head__; } set { if (value.Length <= 4) __head__ = value; } }
        ///<summary>
        /// Version
        ///</summary>
        public int Version { get { return __version__; } set { __version__ = value; } }
        ///<summary>
        /// Filesize
        ///</summary>
        public int Filesize { get { return __filesize__; } set { __filesize__ = value; } }
        ///<summary>
        /// IndexOffset
        ///</summary>
        public int IndexOffset { get { return __indexOffset__; } set { __indexOffset__ = value; MetaStart = IndexOffset + IndexSize; } }
        ///<summary>
        /// IndexSize
        ///</summary>
        public int IndexSize { get { return __indexSize__; } set { __indexSize__ = value; MetaStart = IndexOffset + IndexSize; } }
        ///<summary>
        /// MetaStart
        ///</summary>
        public int MetaStart { get { return __metaStart__; } protected set { __metaStart__ = value; } }
        ///<summary>
        /// MetaSize
        ///</summary>
        public int MetaSize { get { return __metaSize__; } set { __metaSize__ = value; } }
        ///<summary>
        /// NonRawSize
        ///</summary>
        public int NonRawSize { get { return __nonRawSize__; } set { __nonRawSize__ = value; } }
        ///<summary>
        /// Origin
        ///</summary>
        public byte[] Origin { get { return __origin__; } set { if (value.Length <= 256) __origin__ = value; } }
        ///<summary>
        /// BuildDate
        ///</summary>
        public string BuildDate { get { return __buildDate__; } set { if (value.Length <= 32) __buildDate__ = value; } }
        ///<summary>
        /// MapTypeInt
        ///</summary>
        public int MapTypeIndex { get { return __mapTypeIndex__; } set { __mapTypeIndex__ = value; if (MapType != (MapType)value) MapType = (MapType)value; } }
        ///<summary>
        /// MapType
        ///</summary>
        public MapType MapType { get { return __mapType__; } set { __mapType__ = value; if (MapTypeIndex != (int)value) MapTypeIndex = (int)value; } }
        ///<summary>
        /// CrazyOffset
        ///</summary>
        public int CrazyOffset { get { return __crazyOffset__; } set { __crazyOffset__ = value; } }
        ///<summary>
        /// CrazySize
        ///</summary>
        public int CrazySize { get { return __crazySize__; } set { __crazySize__ = value; } }
        ///<summary>
        /// StringsOffset128
        ///</summary>
        public int StringTable128Offset { get { return __stringTable128Offset__; } set { __stringTable128Offset__ = value; } }
        ///<summary>
        /// StringCount
        ///</summary>
        public int StringTableCount { get { return __stringTableCount__; } set { __stringTableCount__ = value; } }
        ///<summary>
        /// StringsSize
        ///</summary>
        public int StringTableSize { get { return __stringTableSize__; } set { __stringTableSize__ = value; } }
        ///<summary>
        /// StringsIndex
        ///</summary>
        public int StringTableIndexOffset { get { return __stringTableIndexOffset__; } set { __stringTableIndexOffset__ = value; } }
        ///<summary>
        /// StringsOffset
        ///</summary>
        public int StringTableOffset { get { return __stringTableOffset__; } set { __stringTableOffset__ = value; } }
        ///<summary>
        /// InternalName
        ///</summary>
        public string InternalName { get { return __internalName__; } set { if (value.Length <= 32) __internalName__ = value; } }
        ///<summary>
        /// ScenarioName
        ///</summary>
        public string ScenarioName { get { return __scenarioName__; } set { if (value.Length <= 256)  __scenarioName__ = value; } }
        ///<summary>
        /// FileTableCount
        ///</summary>
        public int FileTableCount { get { return __fileTableCount__; } set { __fileTableCount__ = value; } }
        ///<summary>
        /// FileTableOffset
        ///</summary>
        public int FileTableOffset { get { return __fileTableOffset__; } set { __fileTableOffset__ = value; } }
        ///<summary>
        /// FileTableSize
        ///</summary>
        public int FileTableSize { get { return __fileTableSize__; } set { __fileTableSize__ = value; } }
        ///<summary>
        /// FileTableIndexOffset
        ///</summary>
        public int FileTableIndexOffset { get { return __fileTableIndexOffset__; } set { __fileTableIndexOffset__ = value; } }
        ///<summary>
        /// Checksum
        ///</summary>
        public int Checksum { get { return __checksum__; } set { __checksum__ = value; } }
        ///<summary>
        /// Foot
        ///</summary>
        public string Foot { get { return __foot__; } set { if (value.Length <= 4) __foot__ = value; } }

        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <param name="map"></param>
        public Header(Map map)
        {
            this.Map = map;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="map"></param>
        /// <param name="br"></param>
        public Header(Map map, BitReader br)
        {
            this.Map = map;
            this.Read(br);
        }

        /// <summary>
        /// 
        /// </summary>
        public void Read()
        {
            BitReader br = new BitReader(Map.FileName, Endian.Little);
            this.Read(br);
            br.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="br"></param>
        public void Read(BitReader br)
        {
            br.BaseStream.Position = 0;

            Head = br.ReadBTFString(4);                // 'deah'
            Version = br.ReadInt32();                  // Halo2: 8
            Filesize = br.ReadInt32();                 //
            br.BaseStream.Position = 16;               // +4
            IndexOffset = br.ReadInt32();              //
            IndexSize = br.ReadInt32();                // 
            MetaStart = IndexOffset + IndexSize;       //
            MetaSize = br.ReadInt32();                 //
            NonRawSize = br.ReadInt32();               // Meta Size + Index Size + BSP Size
            Origin = br.ReadBytes(256);                //
            BuildDate = br.ReadCString(32);            // 00.00.00
            MapTypeIndex = br.ReadInt32();             // 0 = SP, 1 = MP, 2 = MM, 3 = Shared, 4 = SPShared 
            br.BaseStream.Position = 344;              // +20
            CrazyOffset = br.ReadInt32();              //
            CrazySize = br.ReadInt32();                //
            StringTable128Offset = br.ReadInt32();     //
            StringTableCount = br.ReadInt32();         //
            StringTableSize = br.ReadInt32();          //
            StringTableIndexOffset = br.ReadInt32();   //
            StringTableOffset = br.ReadInt32();        //
            br.BaseStream.Position = 408;              // +36
            InternalName = br.ReadCString(32);         // e.g. lockout
            br.BaseStream.Position = 444;              // +4
            ScenarioName = br.ReadCString(256);        // e.g. scenario\multi\lockout\lockout
            br.BaseStream.Position = 704;              // +4
            FileTableCount = br.ReadInt32();           //
            FileTableOffset = br.ReadInt32();          //
            FileTableSize = br.ReadInt32();            //
            FileTableIndexOffset = br.ReadInt32();     //
            Checksum = br.ReadInt32();                 // Every byte after the header(2048) xored
            br.BaseStream.Position = 2044;             // +1320
            Foot = br.ReadBTFString(4);                // 'toof'
        }

        /// <summary>
        /// 
        /// </summary>
        public void Write()
        {
            BitWriter bw = new BitWriter(Map.FileName, Endian.Little);
            this.Write(bw);
            bw.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="bw"></param>
        public void Write(BitWriter bw)
        {
            bw.BaseStream.Position = 0;

            bw.WriteBTFString(Head, 4);
            bw.Write(Version);
            bw.Write(Filesize);
            bw.BaseStream.Position = 16;
            bw.Write(IndexOffset);
            bw.Write(IndexSize);
            bw.Write(MetaSize);
            bw.Write(NonRawSize);
            bw.Write(Origin, 256);
            bw.BaseStream.Position = 288;
            bw.Write(BuildDate, 32);
            bw.BaseStream.Position = 320;
            bw.Write(MapTypeIndex);
            bw.BaseStream.Position = 340;
            bw.Write(CrazySize);
            bw.Write(CrazyOffset);
            bw.BaseStream.Position = 352;
            bw.Write(StringTable128Offset);
            bw.Write(StringTableCount);
            bw.Write(StringTableSize);
            bw.Write(StringTableIndexOffset);
            bw.Write(StringTableOffset);
            bw.BaseStream.Position = 408;
            bw.Write(InternalName, 32);
            bw.BaseStream.Position = 444;
            bw.Write(ScenarioName, 256);
            bw.BaseStream.Position = 704;
            bw.Write(FileTableCount);
            bw.Write(FileTableOffset);
            bw.Write(FileTableSize);
            bw.Write(FileTableIndexOffset);
            bw.Write(Checksum);
            bw.BaseStream.Position = 2044;
            bw.WriteBTFString(Foot);
        }
    }

    /// <summary>
    /// 
    /// </summary>
    public enum MapType
    {
        Single_Player_Map,
        Multi_Player_Map,
        MainMenu,
        Shared,
        Single_Player_Shared
    }
}