using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Extended;

namespace H2UtilityToolkit.Essentials
{
    /// <summary>
    /// 
    /// </summary>
    public class Strings
    {
        #region Instance Data

        private Map __map__;
        private string[] __stringsList__;
        private int[] __offsetsList__;

        #endregion

        #region Accessors

        ///<summary>
        /// Map
        ///</summary>
        protected Map Map { get { return __map__; } set { __map__ = value; } }
        ///<summary>
        /// StringsList
        ///</summary>
        public string[] StringsList { get { return __stringsList__; } set { __stringsList__ = value; } }
        ///<summary>
        /// OffsetsList
        ///</summary>
        public int[] OffsetsList { get { return __offsetsList__; } set { __offsetsList__ = value; } }

        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <param name="map"></param>
        public Strings(Map map)
        {
            this.Map = map;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="map"></param>
        /// <param name="br"></param>
        public Strings(Map map, BitReader br)
        {
            this.Map = map;
            this.Read(br);
        }

        /// <summary>
        /// 
        /// </summary>
        public void Read()
        {
            BitReader br = new BitReader(Map.FileName, Endian.Little);
            this.Read(br);
            br.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="br"></param>
        public void Read(BitReader br)
        {
            // Gather the offsets
            br.BaseStream.Position = Map.Header.StringTableIndexOffset;
            OffsetsList = new int[Map.Header.StringTableCount];
            for (int x = 0; x < Map.Header.StringTableCount; x++)
            {
                OffsetsList[x] = br.ReadInt32();
            }

            // Gather the strings
            StringsList = new string[Map.Header.StringTableCount];
            int indx;
            for (indx = 0; indx < Map.Header.StringTableCount - 1; indx++)
            {
                br.BaseStream.Position = Map.Header.StringTableOffset + OffsetsList[indx];
                StringsList[indx] = br.ReadString(OffsetsList[indx + 1] - OffsetsList[indx]);
            }
            StringsList[indx] = br.ReadString(Map.Header.StringTableSize - OffsetsList[indx]);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="index"></param>
        public void Write(int index)
        {
            BitWriter bw = new BitWriter(Map.FileName, Endian.Little);
            this.Write(bw, index);
            bw.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="bw"></param>
        /// <param name="index"></param>
        public void Write(BitWriter bw, int index)
        {
            bw.BaseStream.Position = OffsetsList[index];
            bw.WriteBTFString(StringsList[index]); // (should be same size for now)
        }

        /// <summary>
        /// 
        /// </summary>
        public void WriteAll()
        {
            BitWriter bw = new BitWriter(Map.FileName, Endian.Little);
            this.WriteAll(bw);
            bw.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="bw"></param>
        public void WriteAll(BitWriter bw)
        {
            for (int x = 0; x < Map.Header.StringTableCount; x++)
            {
                this.Write(bw, x);
            }
        }
    }
}