using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Extended;

namespace H2UtilityToolkit.Misc
{
    /// <summary>
    /// 
    /// </summary>
    public class Preferences
    {
        #region Instance Data

        #region Readonly

        /// <summary>
        /// FileName
        /// </summary>
        public readonly string FileName;

        #endregion

        private Map __map__;
        private string __mainMenuFileName__;
        private string __sPSharedFileName__;
        private string __mPSharedFilename__;
        private bool __mainMenuQueried__;
        private bool __sPSharedQueried__;
        private bool __mPSharedQueried__;
        private bool __bSP_LoadShaders__;
        private bool __bSP_LoadLightmaps__;
        private bool __perms_Load__;
        private bool __perms_LoadShaders__;
        private bool __perms_LoadLightmaps__;
        /*
        private bool __showBipedSpawns__;
        private bool __showCameraSpawns__;
        private bool __showCollectionSpawns__;
        private bool __showControlSpawns__;
        private bool __showDeathZoneSpawns__;
        private bool __showEquipmentSpawns__;
        private bool __showLightSpawnsSpawns__;
        private bool __showMachineSpawns__;
        private bool __showObjectiveSpawns__;
        private bool __showObstacleSpawns__;
        private bool __showPlayerSpawns__;
        private bool __showScenerySpawns__;
        private bool __showSpecialSpawns__;
        private bool __showVehicleSpawns__;
        private bool __showWeaponSpawns__;
        */
        #endregion

        #region Accessors

        ///<summary>
        /// Map
        ///</summary>
        public Map Map { get { return __map__; } set { __map__ = value; } }
        ///<summary>
        /// MainMenuFileName
        ///</summary>
        public string MainMenuFileName { get { return __mainMenuFileName__; } set { __mainMenuFileName__ = value; } }
        ///<summary>
        /// SPSharedFileName
        ///</summary>
        public string SPSharedFileName { get { return __sPSharedFileName__; } set { __sPSharedFileName__ = value; } }
        ///<summary>
        /// MPSharedFilename
        ///</summary>
        public string MPSharedFilename { get { return __mPSharedFilename__; } set { __mPSharedFilename__ = value; } }
        ///<summary>
        /// MainMenuQueried
        ///</summary>
        public bool MainMenuQueried { get { return __mainMenuQueried__; } set { __mainMenuQueried__ = value; } }
        ///<summary>
        /// SPSharedQueried
        ///</summary>
        public bool SPSharedQueried { get { return __sPSharedQueried__; } set { __sPSharedQueried__ = value; } }
        ///<summary>
        /// MPSharedQueried
        ///</summary>
        public bool MPSharedQueried { get { return __mPSharedQueried__; } set { __mPSharedQueried__ = value; } }
        /// <summary>
        /// BSP_LoadShaders
        /// </summary>
        public bool BSP_LoadShaders { get { return __bSP_LoadShaders__; } set { __bSP_LoadShaders__ = value; } }
        /// <summary>
        /// BSP_LoadLightmaps
        /// </summary>
        public bool BSP_LoadLightmaps { get { return __bSP_LoadLightmaps__; } set { __bSP_LoadLightmaps__ = value; } }
        /// <summary>
        /// Perms_Load
        /// </summary>
        public bool Perms_Load { get { return __perms_Load__; } set { __perms_Load__ = value; } }
        /// <summary>
        /// Perms_LoadShaders
        /// </summary>
        public bool Perms_LoadShaders { get { return __perms_LoadShaders__; } set { __perms_LoadShaders__ = value; } }
        /// <summary>
        /// Perms_LoadLightmaps
        /// </summary>
        public bool Perms_LoadLightmaps { get { return __perms_LoadLightmaps__; } set { __perms_LoadLightmaps__ = value; } }
        /*
        /// <summary>
        /// ShowBipedSpawns
        /// </summary>
        public bool ShowBipedSpawns { get { return __showBipedSpawns__; } set { __showBipedSpawns__ = value; } }
        /// <summary>
        /// ShowCameraSpawns
        /// </summary>
        public bool ShowCameraSpawns { get { return __showCameraSpawns__; } set { __showCameraSpawns__ = value; } }
        /// <summary>
        /// ShowCollectionSpawns
        /// </summary>
        public bool ShowCollectionSpawns { get { return __showCollectionSpawns__; } set { __showCollectionSpawns__ = value; } }
        /// <summary>
        /// ShowControlSpawns
        /// </summary>
        public bool ShowControlSpawns { get { return __showControlSpawns__; } set { __showControlSpawns__ = value; } }
        /// <summary>
        /// ShowDeathZoneSpawns
        /// </summary>
        public bool ShowDeathZoneSpawns { get { return __showDeathZoneSpawns__; } set { __showDeathZoneSpawns__ = value; } }
        /// <summary>
        /// ShowEquipmentSpawns
        /// </summary>
        public bool ShowEquipmentSpawns { get { return __showEquipmentSpawns__; } set { __showEquipmentSpawns__ = value; } }
        /// <summary>
        /// ShowLightSpawnsSpawns
        /// </summary>
        public bool ShowLightSpawnsSpawns { get { return __showLightSpawnsSpawns__; } set { __showLightSpawnsSpawns__ = value; } }
        /// <summary>
        /// ShowMachineSpawns
        /// </summary>
        public bool ShowMachineSpawns { get { return __showMachineSpawns__; } set { __showMachineSpawns__ = value; } }
        /// <summary>
        /// ShowObjectiveSpawns
        /// </summary>
        public bool ShowObjectiveSpawns { get { return __showObjectiveSpawns__; } set { __showObjectiveSpawns__ = value; } }
        /// <summary>
        /// ShowObstacleSpawns
        /// </summary>
        public bool ShowObstacleSpawns { get { return __showObstacleSpawns__; } set { __showObstacleSpawns__ = value; } }
        /// <summary>
        /// ShowPlayerSpawns
        /// </summary>
        public bool ShowPlayerSpawns { get { return __showPlayerSpawns__; } set { __showPlayerSpawns__ = value; } }
        /// <summary>
        /// ShowScenerySpawns
        /// </summary>
        public bool ShowScenerySpawns { get { return __showScenerySpawns__; } set { __showScenerySpawns__ = value; } }
        /// <summary>
        /// ShowSpecialSpawns
        /// </summary>
        public bool ShowSpecialSpawns { get { return __showSpecialSpawns__; } set { __showSpecialSpawns__ = value; } }
        /// <summary>
        /// ShowVehicleSpawns
        /// </summary>
        public bool ShowVehicleSpawns { get { return __showVehicleSpawns__; } set { __showVehicleSpawns__ = value; } }
        /// <summary>
        /// ShowWeaponSpawns
        /// </summary>
        public bool ShowWeaponSpawns { get { return __showWeaponSpawns__; } set { __showWeaponSpawns__ = value; } }
        */

        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <param name="map"></param>
        public Preferences(Map map)
        {
            this.Map = map;
            this.FileName = Application.StartupPath + @"\Prefs.cfg";

#if DEBUG
            this.FileName = Path.GetDirectoryName(Application.StartupPath) + @"\Release\Prefs.cfg";
#endif
        }

        /// <summary>
        /// 
        /// </summary>
        public void Read()
        {
            try
            {
                if (File.Exists(FileName))
                {
                    BitReader br = new BitReader(FileName, Endian.Little);

                    MainMenuFileName = br.ReadCString();
                    MPSharedFilename = br.ReadCString();
                    SPSharedFileName = br.ReadCString();

                    //--BSP
                    BSP_LoadShaders = br.ReadBoolean();
                    BSP_LoadLightmaps = br.ReadBoolean();

                    //--Perms
                    Perms_Load = br.ReadBoolean();
                    Perms_LoadShaders = br.ReadBoolean();
                    Perms_LoadLightmaps = br.ReadBoolean();

                    /*
                    //--Spawns
                    ShowBipedSpawns = br.ReadBoolean();
                    ShowCameraSpawns = br.ReadBoolean();
                    ShowCollectionSpawns = br.ReadBoolean();
                    ShowControlSpawns = br.ReadBoolean();
                    ShowDeathZoneSpawns = br.ReadBoolean();
                    ShowEquipmentSpawns = br.ReadBoolean();
                    ShowLightSpawnsSpawns = br.ReadBoolean();
                    ShowMachineSpawns = br.ReadBoolean();
                    ShowObjectiveSpawns = br.ReadBoolean();
                    ShowObstacleSpawns = br.ReadBoolean();
                    ShowPlayerSpawns = br.ReadBoolean();
                    ShowScenerySpawns = br.ReadBoolean();
                    ShowSpecialSpawns = br.ReadBoolean();
                    ShowVehicleSpawns = br.ReadBoolean();
                    ShowWeaponSpawns = br.ReadBoolean();
                    */

                    br.Close();
                    return;
                }
            }
            catch { }

            // Defaults
            MainMenuFileName = string.Empty;
            MPSharedFilename = string.Empty;
            SPSharedFileName = string.Empty;

            //--BSP
            BSP_LoadShaders = true;
            BSP_LoadLightmaps = true;

            //--Perms
            Perms_Load = true;
            Perms_LoadShaders = true;
            Perms_LoadLightmaps = true;

            /*
            //--Spawns
            ShowBipedSpawns = true;
            ShowCameraSpawns = true;
            ShowCollectionSpawns = true;
            ShowControlSpawns = true;
            ShowDeathZoneSpawns = true;
            ShowEquipmentSpawns = true;
            ShowLightSpawnsSpawns = true;
            ShowMachineSpawns = true;
            ShowObjectiveSpawns = true;
            ShowObstacleSpawns = true;
            ShowPlayerSpawns = true;
            ShowScenerySpawns = true;
            ShowSpecialSpawns = true;
            ShowVehicleSpawns = true;
            ShowWeaponSpawns = true;
            */
        }

        /// <summary>
        /// 
        /// </summary>
        public void Write()
        {
            try
            {
                BitWriter bw = new BitWriter(new FileStream(FileName, FileMode.Create,
                    FileAccess.ReadWrite, FileShare.ReadWrite), Endian.Little);

                byte byteNull = 0;
                if (!string.IsNullOrEmpty(MainMenuFileName)) bw.Write(MainMenuFileName);
                bw.Write(byteNull);
                if (!string.IsNullOrEmpty(MPSharedFilename)) bw.Write(MPSharedFilename);
                bw.Write(byteNull);
                if (!string.IsNullOrEmpty(SPSharedFileName)) bw.Write(SPSharedFileName);
                bw.Write(byteNull);

                //--BSP
                bw.Write(BSP_LoadShaders);
                bw.Write(BSP_LoadLightmaps);

                //--Perms
                bw.Write(Perms_Load);
                bw.Write(Perms_LoadShaders);
                bw.Write(Perms_LoadLightmaps);

                /*
                //--Spawns
                bw.Write(ShowBipedSpawns);
                bw.Write(ShowCameraSpawns);
                bw.Write(ShowCollectionSpawns);
                bw.Write(ShowControlSpawns);
                bw.Write(ShowDeathZoneSpawns);
                bw.Write(ShowEquipmentSpawns);
                bw.Write(ShowLightSpawnsSpawns);
                bw.Write(ShowMachineSpawns);
                bw.Write(ShowObjectiveSpawns);
                bw.Write(ShowObstacleSpawns);
                bw.Write(ShowPlayerSpawns);
                bw.Write(ShowScenerySpawns);
                bw.Write(ShowSpecialSpawns);
                bw.Write(ShowVehicleSpawns);
                bw.Write(ShowWeaponSpawns);
                */

                bw.Close();
            }
            catch { }
        }

        /// <summary>
        /// 
        /// </summary>
        public void ResetQueryStates()
        {
            MainMenuQueried = false;
            SPSharedQueried = false;
            MPSharedQueried = false;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rawLoc"></param>
        public string QueryForExternalMap(RawLocation rawLoc)
        {
            switch (rawLoc)
            {
                case RawLocation.Internal:
                    return Map.FileName;

                case RawLocation.MainMenu:
                    if (MainMenuQueried) return string.Empty;
                    break;

                case RawLocation.Shared:
                    if (MPSharedQueried) return string.Empty;
                    break;

                case RawLocation.Single_Player_Shared:
                    if (SPSharedQueried) return string.Empty;
                    break;
            }

            using (OpenFileDialog o = new OpenFileDialog())
            {
                o.Title = string.Format("\"{0}.map\" needed", rawLoc.ToString().ToLower());
                o.Filter = "Map (*.map)|*.map|All Files (*.*)|*.*";

                if (o.ShowDialog() == DialogResult.Cancel)
                {
                    switch (rawLoc)
                    {
                        case RawLocation.MainMenu:
                            MainMenuQueried = true;
                            break;

                        case RawLocation.Shared:
                            MPSharedQueried = true;
                            break;

                        case RawLocation.Single_Player_Shared:
                            SPSharedQueried = true;
                            break;
                    }
                    return string.Empty;
                }
                else
                {
                    switch (rawLoc)
                    {
                        case RawLocation.MainMenu:
                            MainMenuFileName = o.FileName;
                            break;

                        case RawLocation.Shared:
                            MPSharedFilename = o.FileName;
                            break;

                        case RawLocation.Single_Player_Shared:
                            SPSharedFileName = o.FileName;
                            break;
                    }
                    return o.FileName;
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rawLoc"></param>
        public string QueryForExternalMapRegardless(RawLocation rawLoc)
        {
            if (rawLoc == RawLocation.Internal) return Map.FileName;
            using (OpenFileDialog o = new OpenFileDialog())
            {
                o.Title = string.Format("\"{0}.map\" needed", rawLoc.ToString().ToLower());
                o.Filter = "Map (*.map)|*.map|All Files (*.*)|*.*";

                if (o.ShowDialog() != DialogResult.Cancel)
                {
                    switch (rawLoc)
                    {
                        case RawLocation.MainMenu:
                            MainMenuFileName = o.FileName;
                            break;

                        case RawLocation.Shared:
                            MPSharedFilename = o.FileName;
                            break;

                        case RawLocation.Single_Player_Shared:
                            SPSharedFileName = o.FileName;
                            break;
                    }
                    return o.FileName;
                }
                else return string.Empty;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rawLoc"></param>
        public FileStream GetRawStream(RawLocation rawLoc)
        {
            string fileName = string.Empty;

            switch (rawLoc)
            {
                case RawLocation.Internal:
                    fileName = Map.FileName;
                    break;

                case RawLocation.MainMenu:
                    if (string.IsNullOrEmpty(MainMenuFileName)) MainMenuFileName = QueryForExternalMap(rawLoc);
                    fileName = MainMenuFileName;
                    break;

                case RawLocation.Shared:
                    if (string.IsNullOrEmpty(MPSharedFilename)) MPSharedFilename = QueryForExternalMap(rawLoc);
                    fileName = MPSharedFilename;
                    break;

                case RawLocation.Single_Player_Shared:
                    if (string.IsNullOrEmpty(SPSharedFileName)) SPSharedFileName = QueryForExternalMap(rawLoc);
                    fileName = SPSharedFileName;
                    break;
            }

            return (File.Exists(fileName) ? new FileStream(fileName, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite) : null);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rawLoc"></param>
        public FileStream GetRawStreamRegardless(RawLocation rawLoc)
        {
            string fileName = string.Empty;

            switch (rawLoc)
            {
                case RawLocation.Internal:
                    fileName = Map.FileName;
                    break;

                case RawLocation.MainMenu:
                    if (string.IsNullOrEmpty(MainMenuFileName)) MainMenuFileName = QueryForExternalMapRegardless(rawLoc);
                    fileName = MainMenuFileName;
                    break;

                case RawLocation.Shared:
                    if (string.IsNullOrEmpty(MPSharedFilename)) MPSharedFilename = QueryForExternalMapRegardless(rawLoc);
                    fileName = MPSharedFilename;
                    break;

                case RawLocation.Single_Player_Shared:
                    if (string.IsNullOrEmpty(SPSharedFileName)) SPSharedFileName = QueryForExternalMapRegardless(rawLoc);
                    fileName = SPSharedFileName;
                    break;
            }

            return (File.Exists(fileName) ? new FileStream(fileName, FileMode.Open,
                FileAccess.ReadWrite, FileShare.ReadWrite) : null);
        }
    }
}