using System;
using System.Collections.Generic;
using System.Text;
using System.Extended;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Prophet
{
    public class CameraSpawns : SpawnsContainer
    {
        public CameraSpawns()
        {
        }

        public override void Load(BitReader hr, int scnrMetaOffset)
        {
            // Camera - Models
            SpawnModels = new SpawnModel[1];

            // Cameras - Placement
            hr.BaseStream.Position = scnrMetaOffset + 488;

            int cc = hr.ReadInt32();
            int tr = hr.ReadInt32() - Map.index.secondaryMagic;

            Spawns = new CameraSpawn[cc];

            for (int x = 0; x < cc; x++)
            {
                hr.BaseStream.Position = tr + (x * 64) + 36;

                CameraSpawn vs = new CameraSpawn();
                vs.MapOffset = (int)hr.BaseStream.Position;
                vs.X = hr.ReadSingle();
                vs.Y = hr.ReadSingle();
                vs.Z = hr.ReadSingle();
                vs.Roll = hr.ReadSingle();
                vs.Pitch = hr.ReadSingle();
                vs.Yaw = hr.ReadSingle();
                vs.CreateMatrix();
                vs.ModelIndex = 0;

                Spawns[x] = vs;
            }
        }
    }

    public class CameraSpawn : YawPitchRollSpawn
    {
        public float fov;

        public CameraSpawn()
        {
            this.SpawnType = SpawnTypes.Camera;
            this.RotationType = SpawnRotationTypes.YawPitchRoll;
        }
    }
}
