using System;
using System.Collections.Generic;
using System.Text;
using System.Extended;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Prophet
{
    public class CollectionSpawns : SpawnsContainer
    {
        public CollectionSpawns()
        {
        }

        public override void Load(BitReader hr, int scnrMetaOffset)
        {
            // Collections - Models
            SpawnModels = new SpawnModel[1];

            // Collections
            hr.BaseStream.Position = scnrMetaOffset + 288;

            int cc = hr.ReadInt32();
            int tr = hr.ReadInt32() - Map.index.secondaryMagic;

            Spawns = new CollectionSpawn[cc];

            for (int x = 0; x < cc; x++)
            {
                CollectionSpawn vs = new CollectionSpawn();

                hr.BaseStream.Position = tr + (x * 144) + 4;
                vs.SpawnsInMode = (CollectionSpawn.SpawnsInEnum)hr.ReadInt32();

                hr.BaseStream.Position = tr + (x * 144) + 64;
                vs.MapOffset = (int)hr.BaseStream.Position;
                vs.X = hr.ReadSingle();
                vs.Y = hr.ReadSingle();
                vs.Z = hr.ReadSingle();
                vs.Roll = hr.ReadSingle();
                vs.Pitch = hr.ReadSingle();
                vs.Yaw = hr.ReadSingle();
                vs.CreateMatrix();
                vs.ModelIndex = 0;

                //test
                //  if (vs.Pitch > 0) { vs.Pitch = -vs.Pitch; vs.isWeird = true; } else { vs.isWeird = false; }

                /*
                hr.BaseStream.Position = tr + (x * 144) + 92;
                int tempbase = Map.tags.FindTagIndexByID(hr.ReadInt32());
                if (tempbase == -1) continue;

                vs.TagPath = Map.tags.tagsList[tempbase].TagPath;

                vs.ModelTagNumber = tag.FindModelByBaseClass(tempbase, mapLoc);
                if (vs.ModelTagNumber == -1) continue;

                vs.ModelName = Map.tags.tagsList[vs.ModelTagNumber].Path;
                */

                Spawns[x] = vs;
            }
        }
    }

    public class CollectionSpawn : YawPitchRollSpawn
    {
        public SpawnsInEnum SpawnsInMode;

        public CollectionSpawn()
        {
            this.SpawnType = SpawnTypes.Collection;
            this.RotationType = SpawnRotationTypes.YawPitchRoll;

        }
        public enum SpawnsInEnum
        {
            None = 0,
            CTFAndAssault = 1,
            Slayer = 2,
            Oddball = 3,
            KOTHOnly = 4,
            KOTHOnly2 = 5,
            KOTHOnly3 = 6,
            Juggernaut = 7,
            Territories = 8,
            CTFAndAssault2 = 9,
            KOTHOnly4 = 10,
            KOTHOnly5 = 11,
            All = 12,
            AllExceptCTFAndAssault = 13,
            AllExceptCTFAndAssault2 = 14
        }
    }
}
