using System;
using System.Collections.Generic;
using System.Text;
using System.Extended;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Prophet
{
    public class DeathZoneSpawns : SpawnsContainer
    {
        public DeathZoneSpawns()
        {
        }

        public override void Load(BitReader hr, int scnrMetaOffset)
        {
            // DeathZones
            hr.BaseStream.Position = scnrMetaOffset + 264;

            int cc = hr.ReadInt32();
            int tr = hr.ReadInt32() - Map.index.secondaryMagic;

            Spawns = new DeathZoneSpawn[cc];
            SpawnModels = new SpawnModel[cc];

            for (int x = 0; x < cc; x++)
            {
                hr.BaseStream.Position = tr + (x * 68) + 36;

                DeathZoneSpawn dz = new DeathZoneSpawn();
                dz.MapOffset = tr + (68 * x) + 36;
                dz.X = hr.ReadSingle();
                dz.Y = hr.ReadSingle();
                dz.Z = hr.ReadSingle();
                dz.CreateMatrix();
                //   hr.ReadSingle();
                dz.Width = hr.ReadSingle();
                dz.Height = hr.ReadSingle();
                dz.Depth = hr.ReadSingle();
                dz.ModelIndex = x;

                /* ???
                float widthhalf = dz.length / 2;
                // ps.X = ps.X - widthhalf;
                widthhalf = dz.width / 2;
                dz.Y = dz.Y + widthhalf;
                widthhalf = dz.height / 2;
                dz.Z += dz.length / 2;
                //    MessageBox.Show("DeathZone");
                */

                Spawns[x] = dz;
            }
        }
    }

    public class DeathZoneSpawn : BoundingBoxSpawn
    {
        public string Name;
        public DeathZoneSpawn()
        {
            this.SpawnType = SpawnTypes.DeathZone;
            this.RotationType = SpawnRotationTypes.BoundingBox;
        }
    }
}
