using System;
using System.Collections.Generic;
using System.Text;
using System.Extended;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Prophet
{
    public class ObjectiveSpawns : SpawnsContainer
    {
        public ObjectiveSpawns()
        {
        }

        public override void Load(BitReader hr, int scnrMetaOffset)
        {
            // Objectives
            hr.BaseStream.Position = scnrMetaOffset + 280;

            int cc = hr.ReadInt32();
            int tr = hr.ReadInt32() - Map.index.secondaryMagic;

            Spawns = new ObjectiveSpawn[cc];
            SpawnModels = new SpawnModel[0];

            for (int x = 0; x < cc; x++)
            {
                hr.BaseStream.Position = tr + (x * 32);

                ObjectiveSpawn ps = new ObjectiveSpawn();
                ps.MapOffset = tr + (32 * x);
                ps.X = hr.ReadSingle();
                ps.Y = hr.ReadSingle();
                ps.Z = hr.ReadSingle();
                ps.DirRotation = hr.ReadSingle();
                ps.CreateMatrix();
                ps.ObjectiveType = (ObjectiveSpawn.ObjectiveTypeEnum)hr.ReadInt16();
                ps.Team = (ObjectiveSpawn.TeamType)hr.ReadInt16();
                ps.number = hr.ReadInt16();

                /*
                if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.OddballSpawn && ballmodeltag != -1)
                {
                    ps.ModelIndex = ballmodeltag;
                }
                else if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.CTFRespawn && ctfmodeltag != -1)
                {
                    ps.ModelIndex = ctfmodeltag;
                }
                else if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.AssaultRespawn && assultmodeltag != -1)
                {
                    ps.ModelIndex = assultmodeltag;
                }
                else ps.ModelIndex = bipdmodeltag;

                //ps.ModelName = Map.tags.tagsList[ps.ModelTagNumber].Path;
                */

                Spawns[x] = ps;
            }
        }
    }

    public class ObjectiveSpawn : DirectionalSpawn
    {
        public ObjectiveTypeEnum ObjectiveType;
        public TeamType Team;
        public short number;
        public ObjectiveSpawn()
        {
            this.SpawnType = SpawnTypes.Objective;
            this.RotationType = SpawnRotationTypes.Directional;
        }
        public enum ObjectiveTypeEnum
        {
            CTFRespawn = 0,
            CTFScore = 1,
            AssaultRespawn = 2,
            ArmingCircle = 3,
            OddballSpawn = 4,
            TeleporterEntrance = 7,
            TeleporterExit = 8,
            Territory = 10,
            HillVertex1 = 11,
            HillVertex2 = 12,
            HillVertex3 = 13,
            HillVertex4 = 14,
            HillVertex5 = 15,
        }
        public enum TeamType
        {
            Defense = 0,
            Offense = 1,
            Neutral = 8
        }
    }
}
