using System;
using System.Collections.Generic;
using System.Text;
using System.Extended;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Prophet
{
    public class PlayerSpawns : SpawnsContainer
    {
        public PlayerSpawns()
        {
        }

        public override void Load(BitReader hr, int scnrMetaOffset)
        {
            // PlayerSpawns - Models
            SpawnModels = new SpawnModel[1];

            // PlayerSpawns - Placment
            hr.BaseStream.Position = scnrMetaOffset + 256;

            int cc = hr.ReadInt32();
            int tr = hr.ReadInt32() - Map.index.secondaryMagic;

            Spawns = new PlayerSpawn[cc];

            for (int x = 0; x < cc; x++)
            {
                hr.BaseStream.Position = tr + (x * 52);

                PlayerSpawn ps = new PlayerSpawn();
                ps.MapOffset = tr + (52 * x);
                ps.X = hr.ReadSingle();
                ps.Y = hr.ReadSingle();
                ps.Z = hr.ReadSingle();
                ps.DirRotation = hr.ReadSingle();
                ps.CreateMatrix();
                //ps.ModelIndex = bipdmodeltag;
                //ps.ModelName = Map.tags.tagsList[ps.ModelIndex].Path;

                Spawns[x] = ps;
            }
        }

        public override void LoadModels()
        {
            SpawnModels[0].Mesh = Mesh.Box(Map.dev, 0.2f, 0.2f, 0.2f);
        }
    }

    public class PlayerSpawn : DirectionalSpawn
    {
        public PlayerSpawn()
        {
            this.SpawnType = SpawnTypes.Player;
            this.RotationType = SpawnRotationTypes.Directional;
        }
    }
}
