using System;
using System.Collections.Generic;
using System.Text;
using System.Extended;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Prophet
{
    public class VehicleSpawns : SpawnsContainer
    {
        public VehicleSpawns()
        {
        }

        public override void Load(BitReader hr, int scnrMetaOffset)
        {
            // Vehicles - Models
            hr.BaseStream.Position = scnrMetaOffset + 120;

            int cc = hr.ReadInt32();
            int tr = hr.ReadInt32() - Map.index.secondaryMagic;

            SpawnModels = new SpawnModel[cc];
            int[] tagIndices = new int[cc];

            for (int x = 0; x < cc; x++)
            {
                hr.BaseStream.Position = tr + (x * 40) + 4;
                int tagIndx = Map.tags.FindTagIndexByID(hr.ReadInt32());

                tagIndices[x] = tagIndx;
                SpawnModels[x].TagIndex = Map.tags.FindModeTagIndexByBaseClass(hr, tagIndx);

                if (SpawnModels[x].TagIndex == -1) continue;
                SpawnModels[x].TagPath = Map.tags.tagsList[SpawnModels[x].TagIndex].Path;
            }

            // Vehicles - Placement
            hr.BaseStream.Position = scnrMetaOffset + 112;
            cc = hr.ReadInt32();
            tr = hr.ReadInt32() - Map.index.secondaryMagic;

            Spawns = new VehicleSpawn[cc];

            for (int x = 0; x < cc; x++)
            {
                hr.BaseStream.Position = tr + (x * 84);

                short modeIndx = hr.ReadInt16();
                if (modeIndx == -1 || SpawnModels[modeIndx].TagIndex == -1) continue;

                hr.BaseStream.Position += 6;

                VehicleSpawn vs = new VehicleSpawn();
                vs.MapOffset = (int)hr.BaseStream.Position;
                vs.X = hr.ReadSingle();
                vs.Y = hr.ReadSingle();
                vs.Z = hr.ReadSingle();
                vs.Roll = hr.ReadSingle();
                vs.Pitch = hr.ReadSingle();
                vs.Yaw = hr.ReadSingle();
                vs.CreateMatrix();

                vs.ModelIndex = modeIndx;// SpawnModels[modeIndx];
                vs.TagPath = Map.tags.tagsList[tagIndices[modeIndx]].Path;

                Spawns[x] = vs;
            }
        }
    }

    public class VehicleSpawn : YawPitchRollSpawn
    {
        public VehicleSpawn()
        {
            this.SpawnType = SpawnTypes.Vehicle;
            this.RotationType = SpawnRotationTypes.YawPitchRoll;
        }
    }
}
