using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace System.Extended
{
    ///<summary>
    /// 
    ///</summary>
    public class BitWriter : BinaryWriter
    {
        #region Instance Data

        private Endian endian;

        #endregion

        #region Accessors

        ///<summary>
        /// Endian
        ///</summary>
        public Endian Endian { get { return endian; } set { endian = value; } }

        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <param name="fileName"></param>
        /// <param name="endian"></param>
        public BitWriter(string fileName, Endian endian)
            : base(new FileStream(fileName, FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite))
        {
            this.Endian = endian;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="stream"></param>
        /// <param name="endian"></param>
        public BitWriter(Stream stream, Endian endian)
            : base(stream)
        {
            this.Endian = endian;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public override void Write(string value)
        {
            this.Write(value.ToCharArray());
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public void WriteBTFString(string value)
        {
            char[] chars = value.ToCharArray();
            Array.Reverse(chars);
            this.Write(chars);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        /// <param name="length"></param>
        public void Write(string value, int length)
        {
            this.Write(value.ToCharArray());
            this.Write(new byte[length - value.Length]);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        /// <param name="length"></param>
        public void WriteBTFString(string value, int length)
        {
            char[] chars = value.ToCharArray();
            Array.Reverse(chars);
            this.Write(chars);
            this.Write(new byte[length - value.Length]);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="buffer"></param>
        /// <param name="length"></param>
        public void Write(byte[] buffer, int length)
        {
            this.Write(buffer);
            this.Write(new byte[length - buffer.Length]);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public override void Write(short value)
        {
            if (Endian == Endian.Little) base.Write(value);
            else
            {
                byte[] buffer = BitConverter.GetBytes(value);
                Array.Reverse(buffer);
                this.Write(buffer);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public override void Write(int value)
        {
            if (Endian == Endian.Little) base.Write(value);
            else
            {
                byte[] buffer = BitConverter.GetBytes(value);
                Array.Reverse(buffer);
                this.Write(buffer);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public override void Write(float value)
        {
            if (Endian == Endian.Little) base.Write(value);
            else
            {
                byte[] buffer = BitConverter.GetBytes(value);
                Array.Reverse(buffer);
                this.Write(buffer);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public override void Write(double value)
        {
            if (Endian == Endian.Little) base.Write(value);
            else
            {
                byte[] buffer = BitConverter.GetBytes(value);
                Array.Reverse(buffer);
                this.Write(buffer);
            }
        }
    }
}

